'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRedux = require('react-redux');

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _actionCreators = require('./actionCreators');

var ActionCreators = _interopRequireWildcard(_actionCreators);

var _Util = require('./Util');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(_ref) {
  var logEntries = _ref.logEntries,
      highlightedIndex = _ref.highlightedIndex,
      replayTimerId = _ref.replayTimerId,
      replayTimerDelay = _ref.replayTimerDelay;
  return { logEntries: logEntries, highlightedIndex: highlightedIndex, replayTimerId: replayTimerId, replayTimerDelay: replayTimerDelay };
};

var Log = function (_Component) {
  _inherits(Log, _Component);

  function Log() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Log);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Log.__proto__ || Object.getPrototypeOf(Log)).call.apply(_ref2, [this].concat(args))), _this), _this.onKeyDown = function (evt) {
      if (evt.shiftKey) {
        // Require shift to prevent interference with scrolling
        switch (evt.code) {
          case 'ArrowUp':
            _this.props.stepLog(-1);
            break;
          case 'ArrowDown':
            _this.props.stepLog(1);
            break;
        }
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Log, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('keydown', this.onKeyDown);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.onKeyDown);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React.createElement(
        'div',
        { className: 'log' },
        React.createElement(
          'div',
          { className: 'header' },
          React.createElement(
            'span',
            { className: 'title' },
            'Log'
          ),
          ' ',
          React.createElement(_Util.Button, { value: 'clear log', onClick: function onClick() {
              return _this2.props.clearLog();
            } }),
          ' ',
          React.createElement(
            'span',
            { className: 'emoji-button', onClick: function onClick() {
                return _this2.props.stepLog(-1);
              } },
            '\u23EA'
          ),
          this.props.replayTimerId === null ? React.createElement(
            'span',
            { className: 'emoji-button', onClick: function onClick() {
                return _this2.props.startReplay();
              } },
            '\u25B6\uFE0F'
          ) : React.createElement(
            'span',
            { className: 'emoji-button', onClick: function onClick() {
                return _this2.props.pauseReplay();
              } },
            '\u23F8'
          ),
          React.createElement(
            'span',
            { className: 'emoji-button', onClick: function onClick() {
                return _this2.props.stepLog(1);
              } },
            '\u23E9'
          ),
          ' ',
          'Delay:',
          React.createElement(DelaySelector, {
            value: this.props.replayTimerDelay,
            onChange: function onChange(evt) {
              return _this2.props.setDelay(+evt.currentTarget.value);
            }
          }),
          React.createElement(
            'div',
            null,
            '(hover to highlight, shift-up/down to navigate)'
          )
        ),
        React.createElement(Entries, {
          entries: this.props.logEntries,
          highlightedIndex: this.props.highlightedIndex,
          highlight: this.props.highlight
        })
      );
    }
  }]);

  return Log;
}(_react.Component);

var Entries = function (_Component2) {
  _inherits(Entries, _Component2);

  function Entries() {
    var _ref3;

    var _temp2, _this3, _ret2;

    _classCallCheck(this, Entries);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this3 = _possibleConstructorReturn(this, (_ref3 = Entries.__proto__ || Object.getPrototypeOf(Entries)).call.apply(_ref3, [this].concat(args))), _this3), _this3.highlight = function (index) {
      _this3.props.highlight(index);
    }, _temp2), _possibleConstructorReturn(_this3, _ret2);
  }

  _createClass(Entries, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.entries.length !== this.props.entries.length) {
        this.messagesElt.scrollTop = this.messagesElt.scrollHeight - this.messagesElt.clientHeight;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var indexWidth = 1 + Math.log10(this.props.entries.length);
      var componentNameWidth = 2 + Math.max.apply(Math, _toConsumableArray(this.props.entries.map(function (_ref4) {
        var componentName = _ref4.componentName,
            instanceId = _ref4.instanceId;
        return componentName.length + ('' + instanceId).length + 1;
      })));
      return React.createElement(
        'div',
        { className: 'entries', ref: function ref(elt) {
            _this4.messagesElt = elt;
          } },
        this.props.entries.map(function (_ref5, i) {
          var componentName = _ref5.componentName,
              instanceId = _ref5.instanceId,
              methodName = _ref5.methodName;
          return React.createElement(
            'div',
            { className: 'entry-wrapper', key: i },
            React.createElement(
              'div',
              {
                className: 'entry',
                'data-is-highlighted': i === _this4.props.highlightedIndex,
                onMouseEnter: function onMouseEnter() {
                  return _this4.highlight(i);
                }
              },
              ('' + i).padStart(indexWidth) + ' ' + (componentName + '-' + instanceId + ':').padEnd(componentNameWidth) + methodName
            )
          );
        })
      );
    }
  }]);

  return Entries;
}(_react.Component);

var DelaySelector = function DelaySelector(_ref6) {
  var value = _ref6.value,
      onChange = _ref6.onChange;
  return React.createElement(
    'select',
    { value: value, onChange: onChange },
    constants.delayValues.map(function (delay) {
      return React.createElement(
        'option',
        { value: delay, key: delay },
        delay,
        's'
      );
    })
  );
};

exports.default = (0, _reactRedux.connect)(mapStateToProps, ActionCreators, null, { storeKey: constants.reduxStoreKey })(Log);