'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clearLog = undefined;

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _reduxThunk = require('redux-thunk');

var _reduxThunk2 = _interopRequireDefault(_reduxThunk);

var _constants = require('./constants');

var constants = _interopRequireWildcard(_constants);

var _actionCreators = require('./actionCreators');

var actionCreators = _interopRequireWildcard(_actionCreators);

var _reducer = require('./reducer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

if (process.env.NODE_ENV === 'development') {
  console.log('ja');
}

var composeEnhancer = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ || _redux.compose;

var Provider = (0, _reactRedux.createProvider)(constants.reduxStoreKey);

var store = (0, _redux.createStore)(_reducer.reducer, composeEnhancer((0, _redux.applyMiddleware)(_reduxThunk2.default)));

var clearLog = exports.clearLog = function clearLog() {
  return store.dispatch(actionCreators.clearLog());
};
// Store never changes, so we can safely export this bound function.

var VisualizerProvider = function VisualizerProvider(_ref) {
  var children = _ref.children;
  return React.createElement(
    Provider,
    { store: store },
    children
  );
};

exports.default = VisualizerProvider;